variables:
  DATA_SUPPLY_COMMIT: 332b5d6c3eb6152952350c6122d3461faeeae146

# Run full validation of both the repository and datasets, but just in the repository itself.
test:
  stage: build

  image: registry.gitlab.com/datadrivendiscovery/images/core:ubuntu-bionic-python36-devel

  variables:
    GIT_STRATEGY: clone
    # We on purpose do not fetch submodules so that we validate just the current repository.
    # This assumes submodules are validated in their own repositories.
    GIT_SUBMODULE_STRATEGY: none

  before_script:
    - "[ ! -f $(git rev-parse --git-dir)/shallow ] || ( echo 'Repository is shallow.' && exit 1 )"
    - git lfs fetch --all
    - pip3 install cerberus==1.3.1 deep_dircmp==0.1.0
    - git clone --recursive https://gitlab.com/datadrivendiscovery/data-supply.git
    - git -C data-supply checkout "${DATA_SUPPLY_COMMIT}"

  script:
    - |
      set -o errexit
      echo "Checking repository."
      ./git-check.sh
      echo "Updating digests."
      ./update-digest.py
      echo "Validating datasets."
      ./validate.py
      if [ "${CI_COMMIT_REF_NAME}" = master ]; then
        if [ -n "${GIT_ACCESS_USER}" -a -n "${GIT_ACCESS_TOKEN}" ]; then
          echo "Pushing updated digests."
          git remote set-url --push origin "https://${GIT_ACCESS_USER}:${GIT_ACCESS_TOKEN}@${CI_SERVER_HOST}/${CI_PROJECT_PATH}.git"
          git config --local user.email noreply@datadrivendiscovery.org
          git config --local user.name "D3M CI"
          if ! git diff --quiet ; then
            git commit -a -m "Generated by CI." -m "Source commmit: ${CI_COMMIT_SHA}" -m "[skip ci]"
            if [ "${GIT_DEBUG}" = 1 ]; then
              GIT_TRACE=1 GIT_TRANSFER_TRACE=1 GIT_CURL_VERBOSE=1 git push origin HEAD:refs/heads/master
            else
              git push origin HEAD:refs/heads/master &>/dev/null
            fi
          else
            echo "Nothing changed."
          fi
        fi
      fi
    - echo "SUCCESS"

# Run just validator of datasets, but also on git submodule.
test_recursive:
  stage: build

  image: registry.gitlab.com/datadrivendiscovery/images/core:ubuntu-bionic-python36-devel

  variables:
    GIT_STRATEGY: clone
    GIT_SUBMODULE_STRATEGY: recursive

  before_script:
    - "[ ! -f $(git rev-parse --git-dir)/shallow ] || ( echo 'Repository is shallow.' && exit 1 )"
    - git lfs fetch --all
    - git submodule foreach --recursive "git lfs fetch --all"
    - pip3 install cerberus==1.3.1 deep_dircmp==0.1.0
    - git clone --recursive https://gitlab.com/datadrivendiscovery/data-supply.git
    - git -C data-supply checkout "${DATA_SUPPLY_COMMIT}"

  script:
    - |
      set -o errexit
      echo "Validating datasets."
      ./validate.py
    - echo "SUCCESS"

  only:
    refs:
      - master
